divert(-1)
# AnotherLevelUp/fvwm2rc.defines.m4
#
# AnotherLevelUp is an fvwm2 configuration package.
# It is based on Red Hat's AnotherLevel.

# AnotherLevelUp started life as a copy of AnotherLevel-0.6.8-2 (default
# in the RH5.1 distribution). Original Red Hat time stamps have been
# updated as later releases of AnotherLevel have been `assimilated' (!) into
# AnotherLevelUp.

# Author John Latham, Dept. CS, University of Manchester, UK
# Email jtl@cs.man.ac.uk
# Licence: GPL
# Copyright (C) John Latham 1999, 2000, 2001, 2002 and Red Hat Software, Inc

#------------------------------------------------------------------------------

# AnotherLevel - A FVWM2 Configuration
# Copyright (C) 1996, 1997 Red Hat Software, Inc
#
#	$Id: fvwm2rc.defines.m4,v 1.5 1999/04/05 17:00:36 notting Exp $	
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# This work is derived from:
#       TheNextLevel
#       Copyright 1996 By Greg J. Badros <gjb@cs.duke.edu>
# distributed under GNU General Public License.
#

##############################################################################
# This file is m4-included by fvwm2rc.m4
##############################################################################

# Note: This is preprocessed by m4, not cpp!
# a "#define" is a *comment* not a definition!

# Also note: m4 uses matching angled quotes `', not '' or `` like shells

# Please note: There is an ongoing plan to move many of these defines into
# feature-specific component files -- see the files fvwm2rc.comp.*.m4
# for examples.

# Ultimately, a future release of ALU may get rid of this file completely!
# More likely it will be left with only the very esoteric options.

# Please also bear in mind that some of the defines appearing here have not
# been analysed / improved / deleted since AnotherLevel, and may not make much
# sense!

#----------------------------------------------------------------------------

# the name of the root menu
define(`ROOT_MENU', `AUTO_WM_CONFIG')

#----------------------------------------------------------------------------

#This was moved out of fvwm2rc.decors.m4 so can tailor initial windows
#features to suit size of screen.

ifelse( eval(WIDTH > 1024),`1',
                `define(`SCREEN_SIZE',`Huge')',
        eval(WIDTH > 800), `1',
                `define(`SCREEN_SIZE',`Large')',
        eval(WIDTH > 640), `1',
                `define(`SCREEN_SIZE',`Medium')',
        `define(`SCREEN_SIZE',`Small')')

# SCREEN_SIZE gets set to Huge, Large, Moderate, or Small (capitalization matters)
#       Pixels wide      >1024  >800   >640        otherwise
#   Generally for screen  1200  1024    800           640
#       dimensions        x800  x768   x600         x480

#----------------------------------------------------------------------------

# There is a bug in FvwmTaskBar that comes and goes with different releases.
# The bug can cause fvwm2 to crash immediately if a window operation is
# invoked via the start menu button on the task bar. Until this is fixed
# reliably, we avoid the problem here by offering a switch to disable the
# task bar start menu button!

# The start button is enabled by default.
# To disable it, comment the following line (i.e. place a # at the front)
define(`ENABLE_TASKBAR_START_MENU')

#----------------------------------------------------------------------------
# Network connections

# The network connections can be set up to control connections on a remote
# host if desired. To achieve this you must define NETWORK_CONNECTIONS_HOST
# to be the name of the host. If NETWORK_CONNECTIONS_HOST is defined as the
# empty string then connections controlled will be on the local host.

define(`NETWORK_CONNECTIONS_HOST', `')

# If there are any user controllable network connections on the defined host,
# then WANT_NETWORK_CONNECTIONS will be defined by the following.

ifelse(esyscmd(ANOTHERLEVEL/bin/network-connections -test NETWORK_CONNECTIONS_HOST), `', `', `
define(`WANT_NETWORK_CONNECTIONS')
')

#If you do not want any network connections then uncomment this line
#undefine(`WANT_NETWORK_CONNECTIONS')

#If you do want network connections (regardless) then uncomment this line
#define(`WANT_NETWORK_CONNECTIONS')

#----------------------------------------------------------------------------
# Shutdown options

# On the Exit menu, we may want to have shutdown halt and reboot options
# These only appear if /usr/bin/shutdown or /usr/bin/poweroff exist,
# and if WANT_SHUTDOWN_OPTIONS is defined.

define(`WANT_SHUTDOWN_OPTIONS')

#----------------------------------------------------------------------------
# Root xterm

# Comment out below, or later replace it with an undefine, if you do not want
# to be able to start a root su xterm from system utilities. This runs an su
# which promtps for the root password.

define(`WANT_ROOT_XTERM')
#undefine(`WANT_ROOT_XTERM')

#----------------------------------------------------------------------------
# Browse system message log

# Uncomment the undefine below if you do not want the root user to be able to
# start a tail -f of a message log in an rxvt from SystemUtils menu. Change it
# to the most appropriate general log on your system. You will need to be root
# for this to work.

syscmd(`test "$USER" = "root"')
ifelse(sysval,0, `define(`MESSAGE_LOG',`/var/log/messages')')

# undefine(`MESSAGE_LOG')

#----------------------------------------------------------------------------

# USER_HOST_LIST is a list of hosts to allow as options for the hosts menu, etc.
# Any hosts you use frequently should be in here, comma separated, with the 
# whole list enclosed in round parentheses. eg. `(host1, host2, host3)'
#define(`USER_HOST_LIST',`(news,ftp,www)')

#----------------------------------------------------------------------------

# RLOGIN_OR_TELNET should be `rlogin' or `telnet', whichever you'd prefer to 
# use for remote logins
define(`RLOGIN_OR_TELNET',`rlogin')

#----------------------------------------------------------------------------

# The default XTERM used when in X. You can switch it here (usually
# you want  to select between nxterm, xterm and rxvt).
# Also, choose your RXVT program (rxvt is supposed to be a lightweight 
# xterm-like application, so you should avoid using emacs for that value... 
# ;-)

define(`XTERM', `xterm')
define(`RXVT', `rxvt')

#----------------------------------------------------------------------------
#Initial windows - this stuff will certainly be made into module(s) soon!

#These are the default xterm initial option strings

define(`INITXTERM1OPTIONS', `-title "1 Xterm" -geometry 80x53+551+97')
define(`INITXTERM2OPTIONS', `-title "2 Xterm" -geometry 80x25+42+97')
define(`INITXTERM3OPTIONS', `-title "3 Xterm" -geometry 80x25+42+461')

#Now editors: first we here define default Init Option strings for each one
#Later, we read the users Init Windows Script which may overide these
#Then we see which editors are actually available, define for those that are
#and pick a default one
#Then we see which one the user has chosen, and use that if defined :-) !!!

define(`INITXEDITORVimOPTIONS', `-geometry 80x53+42+97')
define(`INITXEDITOREmacsOPTIONS', `-geometry 80x51+41+97')
define(`INITXEDITORXEmacsOPTIONS', `-geometry 74x46+0+98')
define(`INITXEDITORJoveOPTIONS', `-geometry 80x53+42+97')
define(`INITXEDITORPicoOPTIONS', `-geometry 80x53+42+97')
define(`INITXEDITORCoolEditOPTIONS', `-geometry +0+98')
#At nedit 5.1, the geometry option has changed to columns and rows from pixels
#define(`INITXEDITORNeditOPTIONS', `-geometry 505x693+36+97')
define(`INITXEDITORNeditOPTIONS', `-geometry 80x48+36+97')

#now xcal
define(`XCAL', `ical')
define(`INITXCALOPTIONS', `-geometry -90+55')
define(`INITXCAL', `XCAL INITXCALOPTIONS')

#now netscape
IfProgramExists(`netscape', `define(`NETSCAPE', `netscape')')
IfProgramExists(`netscape-navigator', `define(`NETSCAPE', `netscape-navigator')')
IfProgramExists(`netscape-communicator', `define(`NETSCAPE', `netscape-communicator')')

define(`NETSCAPE_DEFAULT', `NETSCAPE NETSCAPEOPTIONS')
define(`NETSCAPEOPTIONS', `-geometry +0+0 -no-about-splash')

#Now the default window start flags
define(`START_XTERM1')
undefine(`START_XTERM2')
undefine(`START_XTERM3')
define(`START_XEDITOR');
undefine(`START_XCAL')
define(`START_BROWSER')

#Now read the host or site specific defines which may override the above
#settings
readFile(`fvwm2rc.hostspecific')

#Now read user choice of Initial Windows, and initial window option strings
changecom(%%%)
ifelse(SCREEN_SIZE, `Huge', `
readFile(`scripts_InitialWindowsSetUp')
',`
readFile(`scripts_InitialWindowsSetUpSmall')
')
changecom(#)

#Now see which editors are available
IfProgramExists(`vim', `
define(`XEDITORVim', `XTERM -e vim')
define(`INITXEDITORVim', `XTERM INITXEDITORVimOPTIONS -e vim')
define(`XEDITOR_CHOICE', Vim)
')

IfProgramExists(`emacs', `
define(`XEDITOREmacs', `emacs')
define(`INITXEDITOREmacs', `emacs INITXEDITOREmacsOPTIONS')
define(`XEDITOR_CHOICE', `Emacs')
')

IfProgramExists(`xemacs', `
define(`XEDITORXEmacs', `xemacs')
define(`INITXEDITORXEmacs', `xemacs INITXEDITORXEmacsOPTIONS')
define(`XEDITOR_CHOICE', `XEmacs')
')

IfProgramExists(`jove', `
define(`XEDITORJove', `XTERM -e jove')
define(`INITXEDITORJove', `XTERM INITXEDITORJoveOPTIONS -e jove')
define(`XEDITOR_CHOICE', `Jove')
')

IfProgramExists(`pico', `
define(`XEDITORPico', `XTERM -e pico')
define(`INITXEDITORPico', `XTERM INITXEDITORPicoOPTIONS -e pico')
define(`XEDITOR_CHOICE', `Pico')
')

IfProgramExists(`cooledit', `
define(`XEDITORCoolEdit', `cooledit')
define(`INITXEDITORCoolEdit', `cooledit INITXEDITORCoolEditOPTIONS')
define(`XEDITOR_CHOICE', `CoolEdit')
')

IfProgramExists(`nedit.static', `
define(`XEDITORNedit', `nedit.static')
define(`INITXEDITORNedit', `nedit.static INITXEDITORNeditOPTIONS')
define(`XEDITOR_CHOICE', `Nedit')
')

IfProgramExists(`nedit', `
define(`XEDITORNedit', `nedit')
define(`INITXEDITORNedit', `nedit INITXEDITORNeditOPTIONS')
define(`XEDITOR_CHOICE', Nedit)
')

#Now get the users choice of editor (if any)
readFile(`scripts_EditorChoice')

#Now define the editor, if available
ifdef(`XEDITOR'XEDITOR_CHOICE, `
define(`XEDITOR', `XEDITOR'XEDITOR_CHOICE)
define(`INITXEDITOR', `INITXEDITOR'XEDITOR_CHOICE)
')

#Now we can define the remaining INIT commands to be used (if selected) at Init
#The user script may have changed the OPTIONS defined above

define(`INITXTERM1', `XTERM INITXTERM1OPTIONS')
define(`INITXTERM2', `XTERM INITXTERM2OPTIONS')
define(`INITXTERM3', `XTERM INITXTERM3OPTIONS')

#----------------------------------------------------------------------------

#Now remaining stuff

# Uncomment for sound events (FvwmAudio) on by default
#define(`WANT_SOUND_EVENTS')

#----------------------------------------------------------------------------

# Window placement styles.
# The old INTERACTIVE_PLACEMENT define has been removed --
# use TILEMANUALPLACEMENT instead

# TILECASCADEPLACEMENT gives non-overlapping if possible, otherwise cascade
#define(`DEFAULT_PLACEMENT', `TILECASCADEPLACEMENT')
# TILEMANUALPLACEMENT gives non-overlapping if possible, otherwise manual
define(`DEFAULT_PLACEMENT', `TILEMANUALPLACEMENT')

# This will become a component with GUI soon.
#----------------------------------------------------------------------------

# OPAQUE_MOVE_SIZE is the percentage of screen that a window must be smaller
# than to be moved opaquely
define(`OPAQUE_MOVE_SIZE',30)

# EDGE_SCROLL_RESISTANCE, EDGE_MOVE_RESISTANCE are numbers given to Fvwm's
# EdgeResistance configuration command.  See fvwm2(1)
define(`EDGE_SCROLL_RESISTANCE',400)
define(`EDGE_MOVE_RESISTANCE',40)

# Uncomment below if you have a win95 keyboard (one w/ the extra keys)
#define(`Win95Keys')

# Uncomment USE_VERTICAL_BUTTON_BARS if you want your tearoff button bars to be vertical
# This is not used now for small button bars
#define(`USE_VERTICAL_BUTTON_BARS')

# The number of columns used for button bars
ifelse(SCREEN_SIZE, `Huge', `define(`BUTTON_BAR_COLUMNS', 3)',
SCREEN_SIZE, `Large', `define(`BUTTON_BAR_COLUMNS', 4)',
SCREEN_SIZE, `Medium', `define(`BUTTON_BAR_COLUMNS', 5)',
`define(`BUTTON_BAR_COLUMNS', 6)')


#----------------------------------------------------------------------------
# System options -- you probably don't need to change these!
#

# N.B: not all of the defines below have been examined / deleted / improved
# since AnotherLevelUp took over from AnotherLevel - YET.
# Some of them do not seem to make much sense / are not used...

#The ALU Web Site
define(`ALU_WEB_SITE', `http://www.cs.man.ac.uk/~jtl/ALU')
define(`ALU_WEB_SITE_THEMES', `http://www.cs.man.ac.uk/~jtl/ALU/themes.html')

# DEPRECATED: use ImagePath since fvwm 2.3.0
# Pixmap Path will always include /usr/X11/include/pixmaps after the below
ifdef(`RH5', `
define(`USER_PIXMAP_PATH',`/usr/X11R6/include/X11/pixmaps/:/usr/share/icons/:/usr/share/icons/mini/`'ANOTHERLEVELICONS')
', `
define(`USER_PIXMAP_PATH',`/usr/X11R6/include/X11/pixmaps/:/usr/share/icons/:/usr/share/icons/mini/:/usr/share/pixmaps/`'ANOTHERLEVELICONS')
')

# DEPRECATED: use ImagePath since fvwm 2.3.0
# Icon (bitmap) path will always include /usr/X11/include/bitmaps after the below
ifdef(`RH5', `
define(`USER_ICON_PATH',`/usr/X11R6/include/X11/bitmaps/:/usr/share/icons/:/usr/share/icons/mini/')
', `
define(`USER_ICON_PATH',`/usr/X11R6/include/X11/bitmaps/:/usr/share/icons/:/usr/share/icons/mini/:/usr/share/pixmaps/:')
')

define(`USER_IMAGE_PATH', `/usr/X11R6/include/X11/pixmaps/:/usr/share/icons/:/usr/share/icons/mini/:/usr/share/pixmaps/`'ANOTHERLEVELICONS')

ifdef(`RH5', `
# USER_MODULE_PATH will always include FVWMDIR (compile time option passed in to FvwmM4)
', `
# USER_MODULE_PATH will always include FVWM_MODULEDIR (compile time option passed in to FvwmM4)
')
define(`USER_MODULE_PATH', `')

# MAIL_SPOOL_DIR is used by Fvwm95's FvwmTaskBarMailBox option.
# Probably will need to use the FvwmM4 define-d `USER' macro to set this one
define(`MAIL_SPOOL_DIR', `esyscmd(echo -n $MAIL)')
ifelse(MAIL_SPOOL_DIR, `', `
define(`MAIL_SPOOL_DIR',`/var/spool/mail/'`'USER)
')

# The directory to use for temporary files created by m4's syscmd, then include-d in
define(`TMPDIR',`/tmp')

# Uncomment for auto generation of host menu-- uses /etc/hosts.
# Comment if you're using NIS, yp, or if you just have a big /etc/hosts file
# (if commented, be sure to set USER_HOST_LIST, below
#define(`AUTO_HOST_MENU')

# XRSH_OR_XON should be either `xon' or `xrsh' whichever you'd prefer for starting x apps
# on a remote machine
define(`XRSH_OR_XON',`xon')

# MOD_SOUND_PATH, MIDI_SOUND_PATH are paths to mod files, midi files for the multimedia
# menu's use
define(`MOD_SOUND_PATH',`/usr/share/sound/mod')
define(`MIDI_SOUND_PATH',`/usr/share/sound/midi')

# Set this directory even if you don't want sound on by default-- it can be turned
# on dynamically.  This directory should include .wav or .au files, or whatever
# SOUND_COMMAND requires
define(`SOUND_DIR',`/usr/share/sound')

# The program to use to play the files in the above directory
# You'll still need to add events in .fvwm2rc.modules to make sounds
# play
define(`SOUND_COMMAND',`play')

# Comment NO_VERIFY_QUIT to provide an extra extra degree of certain about leaving.
# Uncommented, it still is not possible to leave fvwm with a single keystroke (even chorded)
define(`NO_VERIFY_QUIT')

# TITLE_STYLE should be a {justification,appearance} pair from fvwm's TitleStyle option
# justification is one of Centered, RightJustified, or LeftJustified
# appearance is one of Raised, Sunk, or Flat
# This does nothing in Fvwm95
# eg. `Centered Flat'
define(`TITLE_STYLE',`LeftJustified -- flat')

# Change the BORDER_WIDTH to be the number of pixels in a window frame.
# Bigger looks more "solid", but takes up more precious screen real-estate
define(`BORDER_WIDTH',`5')

# BASIC_FONT tells the font style to use generally-- first two parts of a font name, only
define(`BASIC_FONT',`*helvetica')

# FONT_STYLE tells the middle part of a font name.  try `medium-o' for a slanted font
# Be careful not to be too constraining with your choices
define(`FONT_STYLE',`medium-r')

# BASIC_FONT_SIZE is a font size in points
define(`BASIC_FONT_SIZE',`12')

# SMALL_SCREEN_BASIC_FONT_SIZE becomes the BASIC_FONT_SIZE if we're using a small screen
define(`SMALL_SCREEN_BASIC_FONT_SIZE',`10')

# SMALL_FONT is used for button labels, etc.
define(`SMALL_FONT',`5x8')

# MEDIUM_FONT is used for some forms-- should be >= SMALL_FONT, <= BASIC_FONT*BASIC_FONT_SIZE
# (* on above line is wildcard, not multiplication)
define(`MEDIUM_FONT',`fixed')

# ICON_FONT is the font used to label icons
define(`ICON_FONT',`fixed')

# CLICK_MS is the time in ms for clicks to succeed one another to be considered a double
# click
define(`CLICK_MS',	150)

# COLOR_MAP_FOCUS is either FollwsMouse or FollowsFocus
define(`COLOR_MAP_FOCUS',`FollowsFocus')

# The level of niceness to use for commands that will be nice-d
define(`NICELEVEL',`16')

# Set START_MENU_PIXMAP to a small (~60x~25 or so) pixmap to show at the top of
# the FvwmTaskBar's start menu-- only matters if you're using Fvwm95's task bar
define(`START_MENU_PIXMAP',`mini-manuni.xpm')

# Uncomment below if you'd prefer keybindings for cursor movement that are in
# a cross, instead of a VI-style layout (I J K M, instead of vi-like H J K L)
#define(`NOT_VI_KEYS')

# PRINT_FUNCTION gives a shell command to print the window id $w
# xvwd is a script that does: "xwd $* > /tmp/xvwd.$$;xv /tmp/xvwd.$$;rm /tmp/xvwd.$$"
# This doesn't actually print it, but starts xv (version >=3.1) with it in its window
# You may want to use xpr if you have it and have it configured
define(`PRINT_FUNCTION',`xvwd -id $w')

# The font for "big" button bars (w/ fullsize pixmap icons, not mini-pixmaps)
define(`BUTTON_BARS_FONT',`SMALL_FONT')

# Comment the below if you don't want to be able to get tearoff button bars
# containing mini-pixmaps
# These are now panels of buttons persistently toggled on or off
# on the right of the screen
define(`PROVIDE_TEAROFF_BUTTON_BAR')

# Uncomment the below (and probably comment PROVIDE_TEAROFF_BUTTON_BAR, above) if you 
# prefer large pixmap button bar tear-offs
# This is not recommended!
#define(`PROVIDE_TEAROFF_BIG_BUTTON_BAR')

divert
