divert(-1)
# AnotherLevelUp/fvwm2rc.m4
#
# AnotherLevelUp is an fvwm2 configuration package.
# It is based on Red Hat's AnotherLevel.

# AnotherLevelUp started life as a copy of AnotherLevel-0.6.8-2 (default
# in the RH5.1 distribution). Original Red Hat time stamps have been
# updated as later releases of AnotherLevel have been `assimilated' (!) into
# AnotherLevelUp.

# Author John Latham, Dept. CS, University of Manchester, UK
# Email jtl@cs.man.ac.uk
# Licence: GPL
# Copyright (C) John Latham 1999, 2000, 2001, 2002 and Red Hat Software, Inc

#------------------------------------------------------------------------------

# AnotherLevel - A FVWM2 Configuration
# Copyright (C) 1996, 1997 Red Hat Software, Inc
#
#	$Id: fvwm2rc.m4,v 1.4 1999/03/22 23:25:18 pbrown Exp $	
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# This work is derived from:
#       TheNextLevel
#       Copyright 1996 By Greg J. Badros <gjb@cs.duke.edu>
# distributed under GNU General Public License.
#
divert

# ??? This part should get put into the new version-variations script
# We need to see if we are running on RH5.2 or RH6.0!
# We assume we can tell if FVWM_MODULEDIR is set, that we are on RH6.0
# All places affected are marked with ifdef(`RH5'):
#
# ifdef(`RH5', `
# RH5 version of line(s)
# ', `
# RH6 version of line(s)
# ')

# Now see if we have RH5 still:

ifdef(`FVWM_MODULEDIR', `',`
define(`RH5', `YES')
')
#End of RH5/6 hack


###########################################################################
# Look at /tmp/fvwm* output to see what fvwm is defining things
# to be on your platform
#
# Need to muddle with comment characters so these lines don't get ignored by m4,
# but this needs to get passed through fvwm w/o wreaking havoc
changecom(%%%)
#FVWM-M4-Defines
#`SERVERHOST'=SERVERHOST
#`CLIENTHOST'=CLIENTHOST
#`HOSTNAME'=HOSTNAME
#`OSTYPE'=OSTYPE
#`USER'=USER
#`VERSION'=VERSION
#`VENDOR'=VENDOR
#`RELEASE'=RELEASE
#`WIDTH'=WIDTH
#`HEIGHT'=HEIGHT
#`X_RESOLUTION'=X_RESOLUTION
#`Y_RESOLUTION'=Y_RESOLUTION
#`PLANES'=PLANES
#`CLASS'=CLASS
#`COLOR'=COLOR
#`FVWM_VERSION'=FVWM_VERSION
#`OPTIONS'=OPTIONS
ifdef(`RH5', `
#`FVWMDIR'=FVWMDIR
', `
#`FVWMDIR'=FVWM_MODULEDIR
')
#
#`XRELEASE'=RELEASE
changecom(#)

###########################################################################
#Find the location of this file from __file__
#and set ANOTHERLEVEL and ANOTHERLEVELIMAGES accordingly
changequote({, })
esyscmd(cat << . | bash
{
Here=}"__file__"
{
while test -L "\$Here"
do
  Here=\`find "\$Here" -printf %l\`
done
case "\$Here" in
/*) HereDir=\`dirname "\$Here"\` ;;
*/*) HereDir=\`dirname "\$Here"\` ;;
*) HereDir=\`which "\$Here"\`
   HereDir=\`dirname "\$HereDir"\` ;;
esac

echo "define({ANOTHERLEVEL}, {\$HereDir})"
HereDir=\`dirname "\$HereDir"\`
case "\$HereDir" in
/etc/X11)
  echo "define({ANOTHERLEVELICONS}, {})"
  echo "define({ANOTHERLEVELIMAGES}, {/usr/share/AnotherLevelUp/images})"
  echo "define({ANOTHERLEVELPREFERENCES}, {\$HereDir/AnotherLevelUp/SHARED_PREFERENCES})" ;;
*)
  echo "define({ANOTHERLEVELICONS}, {:\$HereDir/ICONS})"
  echo "define({ANOTHERLEVELIMAGES}, {\$HereDir/IMAGES})"
  echo "define({ANOTHERLEVELPREFERENCES}, {\$HereDir/SHARED_PREFERENCES})" ;;
esac
ANOTHERLEVELTTY=\`ps $$|grep $$|sed "s,^ *[0-9]*  *\\([^ ]*\\) .*$,\\1,"\`
echo "define({ANOTHERLEVELTTY}, {\$ANOTHERLEVELTTY})"
.
}
)
changequote(`, ')

changecom(%%%)
#`ANOTHERLEVEL'=ANOTHERLEVEL:
#`ANOTHERLEVELIMAGES'=ANOTHERLEVELIMAGES:
#`ANOTHERLEVELPREFERENCES'=ANOTHERLEVELPREFERENCES:
#`ANOTHERLEVELTTY'=ANOTHERLEVELTTY:
changecom(#)

###########################################################################
# We need to set some specific variations determined by what version of fvwm2
# we have.

esyscmd(ANOTHERLEVEL/bin/set-version-variations FVWM_VERSION)

###########################################################################
# We need to disable locale so that fonts work properly
# (E.g: Version 2.4.6)
ifdef(`DISABLE_LANG', `
SetEnv LANG C
SetEnv LC_CTYPE ""
')
###########################################################################

#Define location of user choice of interface
define(`USER_WM_STYLE',HOME/`.wm_style')

#This was moved out of fvwm2rc.decors.m4 so we can tailor features to suit
#FVWM95 style
syscmd(test -f USER_WM_STYLE)
ifelse(sysval,0,`
define(`WM_STYLE', `translit(translit(sinclude(USER_WM_STYLE),`
'), `a-z', `A-Z')')',`
define(`WM_STYLE', `FVWM95')
')

# make sure we have that decor
syscmd(test -f ANOTHERLEVEL/decors/WM_STYLE)
ifelse(sysval,0,`
',`
define(`WM_STYLE', `FVWM95')
')


#Define the directories where user settings are stored
define(`USER_PREFS_DIR',HOME/`.fvwm2dir')
define(`USER_ALL_THEMES_PREFS_DIR',HOME/`.fvwm2dirAllThemes')


#Make the user settings directory
esyscmd(`test ! -d 'USER_PREFS_DIR` && (mkdir 'USER_PREFS_DIR`; echo "define(\`WELCOME_WANTED')")')

#Select random theme, if desired
ifelse(WM_STYLE, `FVWM95', `
syscmd(ANOTHERLEVEL/bin/preferences-random -path_shared_preferences "ANOTHERLEVELPREFERENCES" -load_random)
')

#Read given file argument, FNAME
#First check for USER_ALL_THEMES_PREFS_DIR/FNAME
#else for USER_PREFS_DIR/FNAME
#else for HOME/.FNAME -- backwards compatibility with AnotherLevel
#else for ANOTHERLEVEL/FNAME.m4
#AFTER reading that file, see if a POST file exists:
#Look for USER_ALL_THEMES_PREFS_DIR/post_FNAME
#else for USER_PREFS_DIR/post_FNAME

esyscmd(ANOTHERLEVEL/bin/define-read-file-macro)

# Using a cache file
# If settings have not changed since last time, then just copy saved file

changequote(,)
define(ALU_RC_FILE, esyscmd(echo -n `ls -t /tmp/fvwmrc*|head -1`))
changequote(`,')

readFile(`fvwm2rc.hostvariants')

ifdef(`ENABLE_CACHE',`

define(`CACHE_FILE', USER_PREFS_DIR`/0-cache-'HOSTVARIANT)
define(`CACHE_SIGNATURE_FILE', USER_PREFS_DIR`/0-cache-'HOSTVARIANT`-signature')

ifelse(esyscmd(cat CACHE_SIGNATURE_FILE 2>/dev/null),
esyscmd(cat USER_WM_STYLE 2>/dev/null; echo $MAIL)USER WIDTH HEIGHT
OSTYPE VERSION RELEASE
X_RESOLUTION Y_RESOLUTION PLANES
CLASS COLOR FVWM_VERSION OPTIONS
ifdef(`RH5', `FVWMDIR', `FVWM_MODULEDIR')
ANOTHERLEVEL
, `
ifelse(esyscmd(ls -t USER_ALL_THEMES_PREFS_DIR/[a-zA-Z]* USER_PREFS_DIR/[a-zA-Z]* CACHE_FILE ANOTHERLEVEL/version-release.m4 2>/dev/null|head -1),
CACHE_FILE`
', `
syscmd(xrdb -merge < USER_PREFS_DIR/0-cache_xresources)
#esyscmd(sed "s|SetEnv ANOTHERLEVELUPTTY .*|SetEnv ANOTHERLEVELUPTTY ANOTHERLEVELTTY|g" < CACHE_FILE > ALU_RC_FILE)dnl
esyscmd(sed \
  -e "s|SetEnv ANOTHERLEVELUPTTY .*|SetEnv ANOTHERLEVELUPTTY ANOTHERLEVELTTY|g" \
  -e "s|Serverhost=.*`,'|Serverhost=SERVERHOST`,'|g" \
  -e "s|Clienthost=.*\"|Clienthost=CLIENTHOST\"|g" \
  -e "s|Hostname=[^`,']*`,'|Hostname=HOSTNAME`,'|g" \
  -e "s|Vendor=.*`,' Release|Vendor=VENDOR`,' Release|g" \
  < CACHE_FILE > ALU_RC_FILE)dnl
m4exit(0)dnl
')
')
')

#  -e "s|Ostype=.*`,'|Ostype=OSTYPE`,'|g" \
#  -e "s|\"Version=.*`,'|\"Version=VERSION`,'|g" \
#  -e "s|Release=.*\"|Release=RELEASE\"|g" \
#  -e "s|X_Resolution=.*`,'|X_Resolution=X_RESOLUTION`,'|g" \
#  -e "s|Y_Resolution=.*\"|Y_Resolution=Y_RESOLUTION\"|g" \
#  -e "s|Planes=[^`,']*`,'|Planes=PLANES`,'|g" \
#  -e "s|Class=.*`,'|Class=CLASS`,'|g" \
#  -e "s|Color=.*\"|Color=COLOR\"|g" \
#  -e "s|Fvwm_Version=.*`,'|Fvwm_Version=FVWM_VERSION`,'|g" \
#  -e "s|Options=.*\"|Options=OPTIONS\"|g" \


# remove cache signature file in case this set up is not completed
syscmd(rm CACHE_SIGNATURE_FILE 2>/dev/null)

# Start error file monitor
define(`PerlTk', esyscmd(ANOTHERLEVEL/bin/perl-tk-test))
ifelse(PerlTk, `Okay', `
define(`ErrorMonitorProcess', esyscmd(ANOTHERLEVEL/bin/monitor-error-file init))
')

ifelse(PLANES, `8', `',`
syscmd(display -window root ANOTHERLEVEL/init-screen-picture-1.jpeg)
')

#Now define corresponding environment variables
ifdef(`RH5', `
',`
SetEnv `ANOTHERLEVELUP' ANOTHERLEVEL
SetEnv `ANOTHERLEVELUPIMAGES' ANOTHERLEVELIMAGES
SetEnv `ANOTHERLEVELUPPREFERENCES' ANOTHERLEVELPREFERENCES
SetEnv `ANOTHERLEVELUPTTY' ANOTHERLEVELTTY
')

# Read the release date as put on the start menu
include(ANOTHERLEVEL`/version-release.m4')

readFile(`fvwm2rc.macros')

# This is ued by error file monitor to find most recent restart text
TraceForErrors(`Start up')

# To keep .fvwm2rc.defines clean, we define default values as necessary 
# through a separate file
readFile(`fvwm2rc.defaults')
readFile(`fvwm2rc.defines')

# Show preferences name
ifelse(WM_STYLE, `FVWM95', `
syscmd(ANOTHERLEVEL/bin/preferences-random -show_pref_name)
')

# Now merge in any Xresources
TraceForErrors(`Making X Resources...')
ifelse(WM_STYLE, `FVWM95', `
syscmd(ANOTHERLEVEL/bin/xresources -all)
',`
syscmd(ANOTHERLEVEL/bin/xresources -default)
')

ifelse(PLANES, `8', `',`
syscmd(display -window root ANOTHERLEVEL/init-screen-picture-2.jpeg)
')

# Now read some more user options
# First some specific files created by scripts and menus
ifelse(WM_STYLE, `FVWM95', `
readFile(`scripts_XSnow')
readFile(`scripts_XEyes')
readFile(`scripts_XEarth')
')

#Now the most general user options
readFile(`fvwm2rc.options')


###############################################################################
# Set our all-important paths.
# Note that your "executables" path (the one your shell uses to search for
# programs it tries to exec) is set *before* fvwm starts.  Usually it is
# set by .xinitrc or .xsession, which hopefully sources some environment
# settings files like /etc/env, /etc/profile, ~/.env, ~/.profile, etc.#
ifdef(`RH5', `
ModulePath FVWMDIR/
', `
ModulePath FVWM_MODULEDIR/
')

ifdef(`USE_PIXMAP_PATH', `
PixmapPath USER_PIXMAP_PATH
IconPath   USER_ICON_PATH
', `
ImagePath USER_IMAGE_PATH
')

# This is the real magic of AnotherLevel - decorations...
# To date it is supposed to work for Win95, Mwm, and Afterstep
TraceForErrors(`Including_decors...')
readFile(`fvwm2rc.decors')

ifdef(`WELCOME_WANTED', `readFile(`fvwm2rc.welcome')')

changecom(%%%)
AddToFunc "SetBackground"
ifelse(BG_MODE, `Solid',   `+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xlock; xsetroot -solid "BG_COLOR"', `')
changequote([,])
ifelse(BG_MODE, [Bitmap], [+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xlock; export histchars=""; ANOTHERLEVEL/bin/load-root-image "`echo "BG_BITMAP" | sed "s,^ ,," | sed "s, $,,"`" "BG_COLOR"], [])
changequote(`,')
ifelse(BG_MODE, `Moving', `+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xlock; exec xlock -nice NICELEVEL -mode BG_MOVING -nolock -inroot', `')
ifelse(BG_MODE, `Mixture', `+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xlock; ANOTHERLEVEL/bin/load-root-image "BG_COLOR" "WINBACK_COLOR"', `')
changecom(#)

###########################################################################
# Stuff to do at start-up
# User initialization is done in .fvwm2rc.init, included at bottom.
##########

AddToFunc "InitFunction"
+ "I" SetupFunction
+ "I" StartupFunction
+ "I" EndSetupFunction

AddToFunc "RestartFunction"
+ "I" SetupFunction
+ "I" EndSetupFunction

###########################################################################
#
# Include all the other support files
#

# Various complex functions
TraceForErrors(`Including_complex functions...')
readFile(`fvwm2rc.functions')

# Include the various components files

TraceForErrors(`Including_components...')
readFile(`fvwm2rc.components')

# Various key bindings
TraceForErrors(`Including_key bindings...')
readFile(`fvwm2rc.keys')

ifelse(PLANES, `8', `',`
syscmd(display -window root ANOTHERLEVEL/init-screen-picture-3.jpeg)
')

# Creation of the menus
TraceForErrors(`Including_menus...')
readFile(`fvwm2rc.menus')

ifelse(PLANES, `8', `',`
syscmd(display -window root ANOTHERLEVEL/init-screen-picture-7.jpeg)
')


# Some style settings
TraceForErrors(`Including_defstyles...')
readFile(`fvwm2rc.defstyles')

# Module settings
TraceForErrors(`Including_modules...')
readFile(`fvwm2rc.modules')

# Initialization
TraceForErrors(`Including_init...')
readFile(`fvwm2rc.init')

###########################################################################
# Local Variables:
# rm-trailing-spaces: t
# page-delimiter: "^#####"
# End:
TraceForErrors(`Done')

# Save output file to cache
changecom(%%%)
ifdef(`ENABLE_CACHE',`
syscmd(egrep -v "^ *#|^ *$" ALU_RC_FILE > CACHE_FILE)
syscmd(cp USER_WM_STYLE CACHE_SIGNATURE_FILE 2>/dev/null;
       echo $MAIL >> CACHE_SIGNATURE_FILE;
       echo "USER WIDTH HEIGHT" >> CACHE_SIGNATURE_FILE;
       echo "OSTYPE VERSION RELEASE" >> CACHE_SIGNATURE_FILE;
       echo "X_RESOLUTION Y_RESOLUTION PLANES" >> CACHE_SIGNATURE_FILE;
       echo "CLASS COLOR FVWM_VERSION OPTIONS">> CACHE_SIGNATURE_FILE;
       echo "ifdef(`RH5', `FVWMDIR', `FVWM_MODULEDIR')" >> CACHE_SIGNATURE_FILE;
       echo "ANOTHERLEVEL" >> CACHE_SIGNATURE_FILE)
')

# Stop error file monitor
ifelse(PerlTk, `Okay', `
syscmd((sleep 5; kill ErrorMonitorProcess 2>/dev/null) &)
')
